One-Core-API

Here you can discuss ReactOS related topics.

Moderator: Moderator Team

Post Reply
reactosuser7
Posts: 86
Joined: Wed Sep 28, 2016 11:53 pm

One-Core-API

Post by reactosuser7 »

This was posted by Svyatpro in
Kernel compatibility layer
topic :
Svyatpro wrote:Check one-core-api compatibility layer for WinXP/2003.

*removed*

This project needs contributors, those he can help it to develop faster.
From https://jira.reactos.org/browse/CORE-12627
There is a project called One-Core-API, this is a compatibility layer for WinXP/2003 to implement NT6 application compatibility. Author and main programmer is a guy called Samuka. Personally, I am a tester/contributor of this project. Our plans is to make NT5.x OS'es be compatible with most NT6-only applications.

This is not just a wrapper, this is a compatibility layer, it replaces native system files with our ones and we use native system files as a source of already implemented functions and all other dependencies. For example, our kernel32.dll(vernel32.dll) has a dependency of native kernel32.dll which has to be renamed to kernelfull.dll. Yes it is rough enough, but it provides the best handling.
[...]

It is a recent post, but
when could ReactOS Project developers include this
One-Core-API
features in ReactOS?

ROCKNROLLKID
Posts: 307
Joined: Mon Oct 17, 2016 3:19 am
Contact:

Re: One-Core-API

Post by ROCKNROLLKID »

Hey, nice find guys. I didn't see that JIRA report before. +1 on this.

But, of course, I assume it will probably take a while for it to be implanted, as I assume some fine tuning will need to be done before it can actually work in ReactOS.

LuxenDM
Posts: 32
Joined: Sun Jan 01, 2017 9:29 pm

Re: One-Core-API

Post by LuxenDM »

how would a "compatibility layer" be different from directly upgrading to NT6 right now? I liked how emuandco put it:
EmuandCo wrote:...was built for NT6+ and thus makes such fuzz. With some tinkering it might work but the result would be bad stuff for other apps because the resulting chimera OS would not follow any of both arches anymore.

ROCKNROLLKID
Posts: 307
Joined: Mon Oct 17, 2016 3:19 am
Contact:

Re: One-Core-API

Post by ROCKNROLLKID »

LuxenDM wrote:how would a "compatibility layer" be different from directly upgrading to NT6 right now? I liked how emuandco put it:
EmuandCo wrote:...was built for NT6+ and thus makes such fuzz. With some tinkering it might work but the result would be bad stuff for other apps because the resulting chimera OS would not follow any of both arches anymore.
Because they are focused on XP/2003 only right now. This is more of a near future solution. Besides, I think they should keep the XP style of things for lightweight use, while using compatibility layers for compatibility with modern day software/games.

petr-akhlamov
Posts: 59
Joined: Wed Apr 10, 2013 3:23 pm
Location: Russia, Moscow

Re: One-Core-API

Post by petr-akhlamov »

One developer already writes compatibility mode, which includes NT6 functions.
http://winehq.org.ru/Compatibility_mode (in russian)

Reports in bugtracker:
*CORE-10366
*CORE-11288

ROCKNROLLKID
Posts: 307
Joined: Mon Oct 17, 2016 3:19 am
Contact:

Re: One-Core-API

Post by ROCKNROLLKID »

Let's not forget about NT10 (Windows 10). Not sure what is worth getting from there, other then maybe Direct X 12.

dsp8195
Posts: 86
Joined: Fri Feb 07, 2014 5:35 am

Re: One-Core-API

Post by dsp8195 »

I've tested this wrapper, and sadly the supplied auto-installer renders the system unbootable. It can be found here (see xXX/Packages directory): *removed*

Tested against Windows XP SP3 and Windows XP x64 SP2.

In the first case, the system stopped with black screen after loading splash.

In the second case, system BSoD'ed with messages about various functions not being found in kernel32, ntdll, etc. etc.

Sadly, unless there will be a reliable way of installation, in the current state One-Core-API cannot be used at all.

Worth noting, though, with help of HEX editor, the supplied libraries can be used to patch certain games to work under Windows NT 5.x. I've managed to run:

* Beat Hazard (new version from Steam)
* HyperLight Drifter (Steam/GoG)
* Shantae: Half-Genie Hero (Steam)

No luck with Saints Row 4 and Saints Row Gat Out Of Hell, because they require Media Foundation libraries and MSVC API wrappers that are somehow missing on XP.

ROCKNROLLKID
Posts: 307
Joined: Mon Oct 17, 2016 3:19 am
Contact:

Re: One-Core-API

Post by ROCKNROLLKID »

I admire what he is doing. If I could run every game and software that would run on win10 on XP, I would so do that. Maybe you should file a issue over at his Github about this?

Have you tested any dx12 games like Ashes of the Singularity, Quantum Break, Hitman, ect?

forart
Posts: 1050
Joined: Mon Nov 29, 2004 1:36 pm
Location: Italy
Contact:

Re: One-Core-API

Post by forart »

Fun, sounds a KernelEx "successor" !
»Forward Agency NPO
In progress we (always) trust.

Post Reply

Who is online

Users browsing this forum: Baidu [Spider], Bing [Bot] and 2 guests